#include <compiler.h>
#include <llvm.h>

fn void llvm_initialize(Module* module)
{
    llvm_initialize_all();

    auto context = LLVMContextCreate();
    auto m = llvm_context_create_module(context, module->name);
    llvm::DIBuilder* di_builder = 0;
    llvm::DICompileUnit* di_compile_unit = 0;
    if (module->has_debug_info)
    {
        di_builder = LLVMCreateDIBuilder(m);
        auto last_slash = string_last_character(module->path, '/');
        if (last_slash == string_no_match)
        {
            report_error();
        }
        auto directory = module->path(0, last_slash);
        auto file_name = module->path(last_slash + 1);
        auto file = LLVMDIBuilderCreateFile(di_builder, file_name.pointer, file_name.length, directory.pointer, directory.length);
        trap_raw();
    }

    trap_raw();
}

void emit(Module* module)
{
    llvm_initialize(module);


    trap_raw();
}
